<?php

	# 		Forecast - Australia
	# 		Namespace:		forecastAU
	#		Meteotemplate Block
	
	#		v1.1 - Nov 09, 2016
	#			- minor bug fixes
	
		
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);
	
	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}	
	
	$weekDays = array(lang('sundayAbbr','c'),lang('mondayAbbr','c'),lang('tuesdayAbbr','c'),lang('wednesdayAbbr','c'),lang('thursdayAbbr','c'),lang('fridayAbbr','c'),lang('saturdayAbbr','c'));
	
	$province = trim(strtoupper($province));
	if($province=="NSW"){
		$zone = "IDN11060";
	}
	else if($province=="NT"){
		$zone = "IDD10207";
	}
	else if($province=="QSL"){
		$zone = "IDQ11295";
	}
	else if($province=="SA"){
		$zone = "IDS10044";
	}
	else if($province=="TAS"){
		$zone = "IDT16710";
	}
	else if($province=="VIC"){
		$zone = "IDV10753";
	}
	else if($province=="WA"){
		$zone = "IDW14199";
	}
	else{
		$zone = "IDN11060";
	}
	
	if(!is_dir("cache")){
		mkdir("cache");
	}
	
	if(file_exists("cache/cache.txt")){
		if (time()-filemtime("cache/cache.txt") > 60 * 60 * 6) {
			unlink("cache/cache.txt");
		}
	}

	if(file_exists("cache/cache.txt")){
		$rawXml = file_get_contents("cache/cache.txt");
	}
	else { 
		$rawXml = file_get_contents("ftp://ftp.bom.gov.au/anon/gen/fwo/".$zone.".xml");
		if($rawXml!=""){
			file_put_contents("cache/cache.txt",$rawXml);
		}
	}
	$xml = simplexml_load_string($rawXml);
	foreach ($xml->forecast[0] as $area){
		$code = (string)$area['aac'];
		$name = (string)$area['description'];
		foreach($area->{"forecast-period"} as $forecastPeriod){
			$conditions = array();
			$currentPeriod = (string)$forecastPeriod['start-time-local'];
			$currentPeriod = str_replace("T"," ",$currentPeriod);
			$currentPeriod = preg_replace("/0\+([0-9][0-9]?:[0-9][0-9]?)/","0",$currentPeriod);
			$startDate = strtotime($currentPeriod);
			foreach($forecastPeriod as $element){
				$type = (string)$element['type'];
				$value = (string)$element;
				$conditions[$type] = $value;
			}
			$data[$code][$startDate] = $conditions;
		}
		$names[$code] = $name;
		$codesAll[] = $code;
	}
	
	// if default is N/A use first one
	if(!in_array($defaultStation,$codesAll)){
		foreach($data as $code=>$values){
			$defaultStation = $code;
		}
	}
?>
	<style>
		.stationAUDiv{
			width:98%;
			margin: 0 auto;
			margin-top:10px;
			margin-bottom:10px;
			display:none;
		}
	</style>
	<?php 
		if(count($data)>0){
	?>
			<select id="stationAUSelector" class="button2">
				<?php
					foreach($data as $code=>$oneStation){
				?>
						<option value="<?php echo $code?>" <?php if($code==$defaultStation){ echo "selected";}?>><?php echo $names[$code]?></option>
				<?php
					}
				?>
			</select>
			<br>
			<?php
				foreach($data as $code=>$oneStation){
			?>
					<div id="<?php echo "stationAU".$code?>" class="stationAUDiv">
						<table class="table" style="width:98%;margin:0 auto" cellpadding="5">
							<thead>
								<tr>
									<th>
										<img src="<?php echo $pageURL.$path?>imgs/flags/big/au.png" style="width:40px">
									</th>
									<th colspan="2" style="font-weight:bold;font-variant:small-caps;font-size:1.3em;text-align:left">
										<?php echo $names[$code]?>
									</th>
									<th>
										<img src="homepage/blocks/forecastAU/icons/<?php echo $theme?>/temp.png" style="width:100%;max-width:25px;padding:5px;">
									</th>
									<th>
										<img src="homepage/blocks/forecastAU/icons/<?php echo $theme?>/rain.png" style="width:100%;max-width:25px;padding:5px;">
									</th>
								</tr>
							</thead>
							<tbody>
								<?php 
									foreach($oneStation as $period=>$values){
								?>
										<tr>
											<th style="width:10%;font-weight:bold;font-size:1.5em;font-variant:small-caps;padding-left:5px">
												<?php echo $weekDays[date("w",$period)];?>
											</th>
											<td style="width:40px">
												<?php 
													if(array_key_exists("forecast_icon_code",$values)){
												?>
														<img src="homepage/blocks/forecastAU/icons/<?php echo $values['forecast_icon_code']?>.png" style="width:35px">
												<?php
													}
												?>
											</td>
											<td style="text-align:left;padding-left:10px;font-variant:small-caps;font-weight:bold">
												<?php 
													if(array_key_exists("precis",$values)){
												?>
														<?php echo str_replace(".","",$values['precis'])?>
												<?php
													}
												?>
											</td>
											<td style="width:20%">
												<?php 
													if(array_key_exists("air_temperature_maximum",$values)){
												?>
														<?php echo $values['air_temperature_maximum']?>&deg;C&nbsp;/&nbsp;
												<?php
													}
												?>
												<?php 
													if(array_key_exists("air_temperature_minimum",$values)){
												?>
														<?php echo $values['air_temperature_minimum']?>&deg;C
												<?php
													}
												?>
											</td>
											<td style="width:20%">
												<?php 
													if(array_key_exists("precipitation_range",$values)){
												?>
														<?php echo $values['precipitation_range']?>
												<?php
													}
												?>
												<?php 
													if(array_key_exists("probability_of_precipitation",$values)){
												?>
														<br><?php echo $values['probability_of_precipitation']?>
												<?php
													}
												?>
											</td>
										</tr>
								<?php 
									}
								?>
							</tbody>
						</table>
					</div>
				
			<?php 
				}
			?>
			<script>
				$("#stationAU<?php echo $defaultStation?>").show();
				$("#stationAUSelector").change(function(){
					selectedAU = $("#stationAUSelector").val();
					$(".stationAUDiv").hide();
					$("#stationAU"+selectedAU).show();
				});
			</script>
	<?php 
		}
		else{
			echo "Data N/A";
		}
	?>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps;text-align:center">
		<?php echo lang('data source','c')?>: Australian Bureau of Meteorology
	</div>